package data;

import java.awt.Graphics2D;
import java.awt.geom.*;
import java.util.*;

public class Label extends Point2D.Double implements Comparable<Label> {
  private static final long serialVersionUID = 3087811683411209532L;
  public String text;
//  public boolean visible = false;
  public int priority;
  
  public Rectangle2D.Double labelRectangle;
  
  public double boundaryY = 0;

  public Label(String text, double x, double y) {
    super(x, y);
    this.text = text;
    if (Holder.INSTANCE!=null)
      priority = Holder.INSTANCE.nextPriority--;
  }

  /**
   * Sortable by Y axis
   */
  @Override
  public int compareTo(Label o) {
    if(o == null) {
      return -1;
    }
    
    return java.lang.Double.compare(y, o.y);
  }
  
  public String toString() {
    return "Label: " + text + ", " + super.toString();
//    return "Label: " + text + ", visible: " + visible + ", " + super.toString();
  }
  
  public void paintLabelBox(Graphics2D g, int fontSize, int index) {
    if(labelRectangle == null) {
      return;
    }
    
//    System.out.println(labelRectangle);
    g.draw(labelRectangle);
//    g.drawString(index + ": " + text, (int) 4, (int) labelRectangle.y + fontSize);
//    g.drawString(text, (int) 4, (int) labelRectangle.y + fontSize);
    g.drawString(text, (int) labelRectangle.x + 4, (int) labelRectangle.y + fontSize);
  }
  
  public void paintDualLine(Graphics2D g, int index, AffineTransform at) {
    Line2D.Double l = getDualLine(index, at);
    gui.Util.drawLine(g, l);
  }
  public Line2D.Double getDualLine(int index, AffineTransform at) {
    double x0=0, x1=5000;
    Point2D s = at.transform(new Point2D.Double(x0, y-index*x0), null);
    Point2D e = at.transform(new Point2D.Double(x1, y-index*x1), null);
    return new Line2D.Double(s.getX(), s.getY(), e.getX(), e.getY());
  }

  public static class PriorityCmp implements Comparator<Label> {
    public int compare(Label a, Label b) {
      return a.priority - b.priority;
    }
    public boolean equals(Label a, Label b) {
      return a==b;
    }
  }
}
