package gui;

import java.awt.Point;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;
import java.awt.geom.AffineTransform;
import java.awt.geom.NoninvertibleTransformException;
import java.awt.geom.Point2D;

import data.Holder;

/*
 * Copy&Paste coding from http://forums.sun.com/thread.jspa?threadID=5397418
 */

public class HorizontalPanListener implements MouseListener, MouseMotionListener,
    MouseWheelListener {

  private Point dragStartScreen;
  private Point dragEndScreen;
  private AffineTransform coordTransform = new AffineTransform();

  public HorizontalPanListener() {
  }

  public void mouseClicked(MouseEvent e) {
  }

  // create new label on right mouse click, otherwise pan
  public void mousePressed(MouseEvent e) {
    dragStartScreen = e.getPoint();
    dragEndScreen = null;
  }

  public void mouseReleased(MouseEvent e) {
    // moveCamera(e);
  }

  public void mouseEntered(MouseEvent e) {
  }

  public void mouseExited(MouseEvent e) {
  }

  public void mouseMoved(MouseEvent e) {
  }

  public void mouseDragged(MouseEvent e) {
    moveCamera(e);
  }

  public void mouseWheelMoved(MouseWheelEvent e) {
  }

  private void moveCamera(MouseEvent e) {
    // System.out.println("============= Move camera ============");
    try {
      dragEndScreen = e.getPoint();
      Point2D.Float dragStart = transformPoint(dragStartScreen);
      Point2D.Float dragEnd = transformPoint(dragEndScreen);
      double dx = dragEnd.getX() - dragStart.getX();
      double dy = dragEnd.getY() - dragStart.getY();
      coordTransform.translate(dx, dy);
      dragStartScreen = dragEndScreen;
      dragEndScreen = null;
      Holder.INSTANCE.window.repaint();
    } catch (NoninvertibleTransformException ex) {
      ex.printStackTrace();
    }
  }

  private Point2D.Float transformPoint(Point p1)
      throws NoninvertibleTransformException {
    // System.out.println("Model -> Screen Transformation:");
    // showMatrix(coordTransform);
    AffineTransform inverse = coordTransform.createInverse();
    // System.out.println("Screen -> Model Transformation:");
    // showMatrix(inverse);

    Point2D.Float p2 = new Point2D.Float();
    inverse.transform(p1, p2);
    return p2;
  }

  public AffineTransform getCoordTransform() {
    return coordTransform;
  }

  public void setCoordTransform(AffineTransform coordTransform) {
    this.coordTransform = coordTransform;
  }
}
