package gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import data.Holder;
import data.Label;

public class Listeners implements MouseListener, ActionListener, ChangeListener {

  @Override
  public void mouseClicked(MouseEvent e) {
  }

  @Override
  public void mouseEntered(MouseEvent e) {
  }

  @Override
  public void mouseExited(MouseEvent e) {
  }

  // Mouse pressed on the left side of the boundary labeling window,
  // show a dialog and add label if needed
  @Override
  public void mousePressed(MouseEvent e) {
    String labelText = (String) JOptionPane.showInputDialog(
        new JFrame(),
        "Enter text for new label:\n", 
        "Label Dialog",
        JOptionPane.PLAIN_MESSAGE);

    if (labelText != null) {
      Label label = new Label(labelText, e.getX(), e.getY());
      Holder.INSTANCE.addLabel(label);
      Holder.INSTANCE.window.repaint();
    }
  }

  @Override
  public void mouseReleased(MouseEvent e) {
  }

  // Clear labels
  @Override
  public void actionPerformed(ActionEvent e) {
    System.out.println("User clicked clear button");
    Holder.INSTANCE.reset();
    Holder.INSTANCE.window.labelsChanged();
  }

  // zoom slider is being moved
  @Override
  public void stateChanged(ChangeEvent e) {
    JSlider source = (JSlider) e.getSource();
    Holder.INSTANCE.setZoomLevel(source.getValue());
  }
}
