package gui;

import javax.swing.*;
import data.*;
import java.awt.event.*;

class OptionsPanel extends JPanel {

  LabelingPanel panel;

  OptionsPanel(LabelingPanel p) {
    this.panel = p;
    setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

    JCheckBox clustering = new JCheckBox("Dynamic clustering");
    clustering.setSelected(Holder.INSTANCE.dynamicClustering);
    clustering.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        Holder.INSTANCE.dynamicClustering = e.getStateChange()==e.SELECTED;
        Holder.INSTANCE.generate();
        Holder.INSTANCE.window.repaint();
      }
    });
    add(clustering);

    LabelCanvas lcanvas = panel.labelCanvas;
    /*
    JCheckBox internal = new JCheckBox("Internal labels");
    internal.setSelected(lcanvas.internalLabels);
    internal.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        LabelCanvas lcanvas = panel.labelCanvas;
        lcanvas.internalLabels = e.getStateChange()==e.SELECTED;
        panel.repaint();
      }
    });
    add(internal);
    */

    JCheckBox visible = new JCheckBox("Label only visible sites");
    visible.setSelected(Holder.INSTANCE.onlyVisible);
    visible.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        Holder.INSTANCE.onlyVisible = e.getStateChange()==e.SELECTED;
        panel.repaint();
      }
    });
    add(visible);

    JCheckBox limits = new JCheckBox("Keep labels within screen limits");
    limits.setSelected(Holder.INSTANCE.keepOnScreen);
    limits.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        Holder.INSTANCE.keepOnScreen = e.getStateChange()==e.SELECTED;
        panel.repaint();
      }
    });
    add(limits);
  }
}
