package gui;

import javax.swing.*;
import java.util.*;
import java.awt.event.*;
import java.awt.Graphics;
import data.*;

public class PriorityList extends JPanel implements ActionListener {
  PriorityListModel model;
  JList list;
  List<Label> labels = new ArrayList<Label>(Holder.INSTANCE.labels);

  PriorityList() {
    model = new PriorityListModel();
    list = new JList(model);
    // TODO: dragging
//    list.setDragEnabled(true);
    generate();

    setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

    add(new JLabel("Label priorities"));

    JScrollPane scroll = new JScrollPane(list,
        ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,
        ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
    scroll.setSize(10, 100);
    add(scroll);

    JPanel buttons = new JPanel();
    buttons.setLayout(new BoxLayout(buttons, BoxLayout.Y_AXIS));
    for(String[] s : new String[][]{
        {"Move up", "up"},
        {"Move down", "down"},
        {"Delete", "delete"}})
    {
      JButton b = new JButton(s[0]);
      b.setActionCommand(s[1]);
      b.addActionListener(this);
      buttons.add(b);
    }
    add(buttons);
//    setSize(10, 50);
  }
  public void paint(Graphics g) {
//    list.setFixedCellWidth(getWidth());
    super.paint(g);
  }

  void generate() {
    labels = new ArrayList<Label>(Holder.INSTANCE.labels);
    labels.addAll(Holder.INSTANCE.lowPriority);
    Collections.sort(labels, new Label.PriorityCmp());

    System.out.println();
    for(Label l : labels) {
      System.out.printf("new Label(\"%s\", %f, %f),\n", l.text, l.x, l.y);
    }

//    System.out.println("lol labels: "+labels.size());
    model.update();
    repaint();
  }

  public void actionPerformed(ActionEvent e) {
    String s = e.getActionCommand();
    int[] cs = list.getSelectedIndices();
    if (s.equals("up")) {
      for(int i=0; i<cs.length; ++i) {
        int c = cs[i];
        if (c>0 && (i==0 || cs[i-1]!=c-1)) {
          swapLabels(c-1, c);
          cs[i]--;
        }
      }
    } else if (s.equals("down")) {
      for(int i=cs.length-1; i>=0; --i) {
        int c = cs[i];
        if (c<labels.size()-1 && (i==cs.length-1 || cs[i+1]!=c+1)) {
          swapLabels(c, c+1);
          cs[i]++;
        }
      }
    } else if (s.equals("delete")) {
      for(int c : cs) {
//        Holder.INSTANCE.labels.remove(c);
        Holder.INSTANCE.allLabels.remove(labels.get(c));
      }
      cs=new int[0];
    }
    list.setSelectedIndices(cs);
    Holder.INSTANCE.window.repaint();
  }
  void swapLabels(int a, int b) {
      Label t = labels.get(a);
      Label u = labels.get(b);
      int p = t.priority;
      t.priority = u.priority;
      u.priority = p;
      labels.set(a, u);
      labels.set(b, t);
  }

  class PriorityListModel extends AbstractListModel {
    public Object getElementAt(int i) {
      return labels.get(i).text;
    }
    public int getSize() {
      return labels.size();
    }
    void update() {
      fireContentsChanged(this, 0, getSize());
    }
  }
}
